package fr.username404.snowygui.gui

import net.minecraft.client.gui.GuiGraphics
import net.minecraft.client.gui.screens.Screen
import net.minecraft.network.chat.Component.translatable

abstract class SnowyScreen(translatableString: String = "screen.snowy.gui", private val willPauseScreen: Boolean = false): Screen(translatable(translatableString)) {
    abstract val components: MutableCollection<Element>
    override fun render(guiGraphics: GuiGraphics, i: Int, j: Int, f: Float) {
        components.forEach {
            it.display(guiGraphics)
        }
    }
    override fun isPauseScreen(): Boolean = willPauseScreen
}